#include <stdio.h>
#include <windows.h>
#include <math.h>

char port[15] = "\\\\.\\COM3"; //  ø Ʈ

#define delay_value 50 // ޴ ð 0.05

typedef struct SensorData1 {
	int CDS;
	int IR[7];
	int Bat;
	int Acc[3];
	int Mag[3];
	int Gyro[3];
	int MCur[2];
	int Temp;
	int StVar;
	int StCur;
	int Remote;
	int MTemp;
    int CNT;
}SensorData;

HANDLE AltinoComDevId;
unsigned char tx_d[28] = { 0, };
unsigned char Sendbuf[28] = { 0, };
unsigned char rx_d[56] = { 0, };
unsigned char rx_d56[56]= { 0, };
unsigned char rx_d_sensor1[56] = { 0, };
unsigned int speed = 0;
unsigned char connectstate = 0;
DWORD dwByte;
HANDLE thread;
SensorData sensor;
SensorData SensorFun(int command);

void delay(int ms);

// 忡 ؼ  Լ.  Լ ϸ 嵵 ȴ
DWORD WINAPI thtimer(void* data) {
    while (1) {
        sensor=SensorFun(10);
        delay(delay_value);
    }
    return 0;
}

unsigned char check_sum_tx_calcuration(int u16_cnt)
{
	int u16_tx_check_sum = 0;
	int u16_tx_cnt;
	u16_tx_check_sum = u16_tx_check_sum + tx_d[1];
	for (u16_tx_cnt = 3; u16_tx_cnt <= u16_cnt; u16_tx_cnt++) {
		u16_tx_check_sum = u16_tx_check_sum + tx_d[u16_tx_cnt];
	}
	u16_tx_check_sum = u16_tx_check_sum % 256;
	return (byte)(u16_tx_check_sum);
}

void delay(int ms)
{
    Sleep(ms);
}

void Delay(int ms)
{
    delay(ms);
}

void Open()
{
	if (connectstate == 0)
	{
		AltinoComDevId = CreateFile(
			port,
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			0,
			NULL);

		COMMTIMEOUTS CommTimeOuts;
		GetCommTimeouts(AltinoComDevId, &CommTimeOuts);
		CommTimeOuts.ReadIntervalTimeout = 500;
		CommTimeOuts.ReadTotalTimeoutMultiplier = 500;
		CommTimeOuts.ReadTotalTimeoutConstant = 500;
		CommTimeOuts.WriteTotalTimeoutMultiplier = 500;
		CommTimeOuts.WriteTotalTimeoutConstant = 500;
		SetCommTimeouts(AltinoComDevId, &CommTimeOuts);

		DCB dcb;
		GetCommState(AltinoComDevId, &dcb);
		dcb.BaudRate = CBR_115200;
		dcb.ByteSize = 8;
		dcb.Parity = NOPARITY;
		dcb.StopBits = 0;
		dcb.fBinary = TRUE;
		dcb.fParity = FALSE;

		SetCommState(AltinoComDevId, &dcb);
		Sleep(500);
		connectstate = 1;
		sensor.CNT=0;
		thread = CreateThread(NULL, 0, thtimer, NULL, 0, NULL);
	}
}

void BT()
{
    Open();
}

void Bt()
{
    Open();
}

void bt()
{
    Open();
}

void OPEN()
{
    Open();
}

void Close()
{
	if (connectstate == 1)
	{
		Sleep(500);
		CloseHandle(AltinoComDevId);
		connectstate = 0;
	}
}

void close()
{
    Close();
}

void ClOSE()
{
    Close();
}

void SendData(unsigned char *Sendbuf)
{
    int i;
	tx_d[0] = 0x2;
	tx_d[1] = 28;

	tx_d[3] = 1;
	tx_d[4] = 10;

	for(i=5; i<21; i++){
        tx_d[i] = Sendbuf[i];
	}

	if (Sendbuf[4] == 1 || Sendbuf[4]==10) {
	    Sendbuf[21] = Sendbuf[21] | 0x01;
	}
	else  {
	    Sendbuf[21] = Sendbuf[21];
    }

    for(i=21; i<26; i++){
        tx_d[i] = Sendbuf[i];
    }

	tx_d[26] = 255;
	tx_d[27] = 0x3;

	tx_d[2] = check_sum_tx_calcuration(27);

	PurgeComm(AltinoComDevId, PURGE_TXCLEAR);
	WriteFile(AltinoComDevId, tx_d, 28, &dwByte, 0);
}

void Go(int left, int right)
{
    Sendbuf[6] = 0;
    Sendbuf[9] = 0;
    if (left>1000)
    	left = 1000;
    else if (left<-1000)
    	left = -1000;

    if (left<0)
    	left = 32768 - left;

    if (right>1000)
    	right = 1000;
    else if (right<-1000)
    	right = -1000;

    if (right<0)
    	right = 32768 - right;

    if (right==0)
    	Sendbuf[6] = 255;
    else
    	Sendbuf[6] = 0;

    Sendbuf[7] = (byte)(right / 256);
    Sendbuf[8] = (byte)(right % 256);

    if (left == 0)
    	Sendbuf[9] = 255;
    else
    	Sendbuf[9] = 0;

    Sendbuf[10] = (byte)(left / 256);
    Sendbuf[11] = (byte)(left % 256);
}

void go(int left, int right)
{
    Go(left,right);
}

void GO(int left, int right)
{
    Go(left,right);
}

void Steering(int value)
{
    if(value>120)
    	value=120;
    if(value<-120)
    	value=-120;
    if(value<0)
    	value=128-value;
    if(value==120)
    {
        Sendbuf[24] = 0;
        Sendbuf[5] = (byte)3;
        Sendbuf[25]=0;
    }
    else if(value==248)
    {
        Sendbuf[24] = 0;
        Sendbuf[5] = (byte)1;
        Sendbuf[25]=0;
    }
    else
    {
        Sendbuf[24] = 1;
        Sendbuf[5] = (byte)value;
        Sendbuf[25]=0;
    }
}

void steering(int value)
{
    Steering(value);
}

void STEERING(int value)
{
    Steering(value);
}

void Sound(unsigned char buzzer)
{
    Sendbuf[22] = (byte)buzzer;
}

void sound(unsigned char buzzer)
{
    Sound(buzzer);
}

void SOUND(unsigned char buzzer)
{
    Sound(buzzer);
}

void Display(unsigned char ASCII)
{
    if(ASCII>128)
       ASCII=ASCII-128;
    else if(ASCII>0)
        ASCII = 128+ASCII;

    Sendbuf[12] = ASCII;
    Sendbuf[13] = 0;
    Sendbuf[14] = 0;
    Sendbuf[15] = 0;
    Sendbuf[16] = 0;
    Sendbuf[17] = 0;
    Sendbuf[18] = 0;
    Sendbuf[19] = 0;
    Sendbuf[20] = 0;
}

void display(unsigned char ASCII)
{
    Display(ASCII);
}

void DISPLAY(unsigned char ASCII)
{
    Display(ASCII);
}

void DisplayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    Sendbuf[12] = 0;
    Sendbuf[13] = dot7;
    Sendbuf[14] = dot6;
    Sendbuf[15] = dot5;
    Sendbuf[16] = dot4;
    Sendbuf[17] = dot3;
    Sendbuf[18] = dot2;
    Sendbuf[19] = dot1;
    Sendbuf[20] = dot0;
}

void displayline(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void displayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void DISPLAYLINE(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void Led(unsigned int led)
{
    Sendbuf[23] = (byte)(led%256);
    Sendbuf[21] = (byte) (led/256);
}

void led(unsigned int led)
{
    Led(led);
}

void LED(unsigned int led)
{
    Led(led);
}

void Light(unsigned int led)
{
    Led(led);
}

void light(unsigned int led)
{
    Led(led);
}

void LIGHT(unsigned int led)
{
    Led(led);
}

void Displayon(int x, int y)
{
    unsigned char dotx;
    if(y<1||y>8 || x<1 || x>8)
        printf("1 8̿  Էϼ.");
    else {
        Sendbuf[12] = 0;
        dotx=Sendbuf[21-x];

        Sendbuf[21-x] = dotx | (unsigned char)pow((double)2,(double)(y-1));
    }
}

void displayon(int x, int y)
{
    Displayon(x,y);
}

void DisplayOn(int x, int y)
{
    Displayon(x,y);
}

void DisplayON(int x, int y)
{
    Displayon(x,y);
}

void DISPLAYON(int x, int y)
{
    Displayon(x,y);
}

void Displayoff(int x, int y)
{
    unsigned char dotx;
    Sendbuf[12] = 0;
    if(x<1||x>8 || y<1 || y>8)
        printf("1 8̿  Էϼ.");
    dotx=Sendbuf[21-x];

    Sendbuf[21-x] = dotx & ((byte)(255-pow((double)2,(double)(y-1))));
}

void displayoff(int x, int y)
{
    Displayoff(x,y);
}

void DisplayOff(int x, int y)
{
    Displayoff(x,y);
}

void DisplayOFF(int x, int y)
{
    Displayoff(x,y);
}

void DISPLAYOFF(int x, int y)
{
    Displayoff(x,y);
}


void Stop()
{
    Go(0,0);Steering(0);
    Sound(0);Led(0);
    Display(0);
}

void stop()
{
    Stop();
}

SensorData SensorFun(int command)
{
    int i,j,k;
    SensorData sensordata1;
    Sendbuf[4] = (byte)command;
    SendData(Sendbuf);

    ReadFile(AltinoComDevId, rx_d, 56, &dwByte, 0);

    for(j=0; j<56; j++)
    {
        for(i=0; i<55; i++)
        {
            rx_d56[i]=rx_d56[i+1];
        }
        rx_d56[55]=rx_d[j];
        int rx_check_sum=0;
        if ((rx_d56[0] == 2) && (rx_d56[55] == 3) && (rx_d56[1] == 56)) {
            rx_check_sum = rx_d56[0];
            rx_check_sum = rx_check_sum + rx_d56[1];
            for(k=3; k<56; k++)
                rx_check_sum = rx_check_sum + rx_d56[k];

            rx_check_sum = rx_check_sum % 256;
            if (rx_check_sum==rx_d56[2])
            {
                for(k=7; k<54; k++)
                    rx_d_sensor1[k] = rx_d56[k];
                for(k=0; k<56; k++)
                    rx_d56[k]=0;
                break;
            }
        }
    }
    PurgeComm(AltinoComDevId, PURGE_RXCLEAR);

    sensordata1.IR[1] = rx_d_sensor1[7] * 256 + rx_d_sensor1[8];
    sensordata1.IR[2] = rx_d_sensor1[9] * 256 + rx_d_sensor1[10];
    sensordata1.IR[3] = rx_d_sensor1[11] * 256 + rx_d_sensor1[12];
    sensordata1.IR[4] = rx_d_sensor1[13] * 256 + rx_d_sensor1[14];
    sensordata1.IR[5] = rx_d_sensor1[15] * 256 + rx_d_sensor1[16];
    sensordata1.IR[6] = rx_d_sensor1[17] * 256 + rx_d_sensor1[18];

    sensordata1.MCur[0] = rx_d_sensor1[19] * 256 + rx_d_sensor1[20];
    sensordata1.MCur[1] = rx_d_sensor1[21] * 256 + rx_d_sensor1[22];

    sensordata1.Temp = rx_d_sensor1[49] * 256 + rx_d_sensor1[50];
    sensordata1.CDS = rx_d_sensor1[43] * 256 + rx_d_sensor1[44];

    sensordata1.Acc[0] = rx_d_sensor1[25] * 256 + rx_d_sensor1[26];
    sensordata1.Acc[1] = rx_d_sensor1[27] * 256 + rx_d_sensor1[28];
    sensordata1.Acc[2] = rx_d_sensor1[29] * 256 + rx_d_sensor1[30];

    int temp=0;
    temp=sensordata1.Acc[0]/16;
    sensordata1.Acc[0]=temp;
    if(temp>2048) sensordata1.Acc[0]=sensordata1.Acc[0]-4096;

    temp=sensordata1.Acc[1]/16;
    sensordata1.Acc[1]=temp;
    if(temp>2048) sensordata1.Acc[1]=sensordata1.Acc[1]-4096;

    temp=sensordata1.Acc[2]/16;
    sensordata1.Acc[2]=temp;
    if(temp>2048) sensordata1.Acc[2]=sensordata1.Acc[2]-4096;

    sensordata1.Mag[0] = rx_d_sensor1[31] * 256 + rx_d_sensor1[32];
    sensordata1.Mag[1] = rx_d_sensor1[33] * 256 + rx_d_sensor1[34];
    sensordata1.Mag[2] = rx_d_sensor1[35] * 256 + rx_d_sensor1[36];

    sensordata1.StVar = rx_d_sensor1[45] * 256 + rx_d_sensor1[46];
    sensordata1.StCur = rx_d_sensor1[23] * 256 + rx_d_sensor1[24];
    sensordata1.Bat = rx_d_sensor1[47] * 256 + rx_d_sensor1[48];

    sensordata1.Remote = rx_d_sensor1[51];
    sensordata1.MTemp = rx_d_sensor1[52];

    sensordata1.Gyro[0] = rx_d_sensor1[37] * 256 + rx_d_sensor1[38];
    sensordata1.Gyro[1] = rx_d_sensor1[39] * 256 + rx_d_sensor1[40];
    sensordata1.Gyro[2] = rx_d_sensor1[41] * 256 + rx_d_sensor1[42];

    if(sensordata1.Acc[0]>32768)
        sensordata1.Acc[0]=sensordata1.Acc[0]-65535;
    if(sensordata1.Acc[1]>32768)
        sensordata1.Acc[1]=sensordata1.Acc[1]-65535;
    if(sensordata1.Acc[2]>32768)
        sensordata1.Acc[2]=sensordata1.Acc[2]-65535;
    if(sensordata1.Mag[0]>32768)
        sensordata1.Mag[0]=sensordata1.Mag[0]-65535;
    if(sensordata1.Mag[1]>32768)
        sensordata1.Mag[1]=sensordata1.Mag[1]-65535;
    if(sensordata1.Mag[2]>32768)
        sensordata1.Mag[2]=sensordata1.Mag[2]-65535;
     if(sensordata1.Gyro[0]>32768)
        sensordata1.Gyro[0]=sensordata1.Gyro[0]-65535;
    if(sensordata1.Gyro[1]>32768)
        sensordata1.Gyro[1]=sensordata1.Gyro[1]-65535;
    if(sensordata1.Gyro[2]>32768)
        sensordata1.Gyro[2]=sensordata1.Gyro[2]-65535;

    sensordata1.CNT = sensordata1.CNT +1;
	return sensordata1;
}
